Index: trunk/src/VBox/Additions/x11/VBoxClient/clipboard.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/clipboard.cpp	(revision 80990)
+++ trunk/src/VBox/Additions/x11/VBoxClient/clipboard.cpp	(revision 81028)
@@ -291,8 +291,5 @@
 
     /* Initialise the guest library. */
-    int rc = VbglR3InitUser();
-    if (RT_FAILURE(rc))
-        VBClFatalError(("Failed to connect to the VirtualBox kernel service, rc=%Rrc\n", rc));
-    rc = SharedClipboardSvcImplConnect();
+    int rc = SharedClipboardSvcImplConnect();
     /* Not RT_SUCCESS: VINF_PERMISSION_DENIED is host service not present. */
     if (rc == VINF_SUCCESS)
Index: trunk/src/VBox/Additions/x11/VBoxClient/display-svga-x11.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/display-svga-x11.cpp	(revision 80990)
+++ trunk/src/VBox/Additions/x11/VBoxClient/display-svga-x11.cpp	(revision 81028)
@@ -245,8 +245,4 @@
     if (x11Context.pDisplay == NULL)
         return VINF_SUCCESS;
-    /* Initialise the guest library. */
-    rc = VbglR3InitUser();
-    if (RT_FAILURE(rc))
-        VBClFatalError(("Failed to connect to the VirtualBox kernel service, rc=%Rrc\n", rc));
     rc = VbglR3CtlFilterMask(VMMDEV_EVENT_DISPLAY_CHANGE_REQUEST, 0);
     if (RT_FAILURE(rc))
Index: trunk/src/VBox/Additions/x11/VBoxClient/display-svga.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/display-svga.cpp	(revision 80990)
+++ trunk/src/VBox/Additions/x11/VBoxClient/display-svga.cpp	(revision 81028)
@@ -188,8 +188,4 @@
     if (drmContext.hDevice == NIL_RTFILE)
         return VINF_SUCCESS;
-    /* Initialise the guest library. */
-    rc = VbglR3InitUser();
-    if (RT_FAILURE(rc))
-        VBClFatalError(("Failed to connect to the VirtualBox kernel service, rc=%Rrc\n", rc));
     rc = VbglR3CtlFilterMask(VMMDEV_EVENT_DISPLAY_CHANGE_REQUEST, 0);
     if (RT_FAILURE(rc))
Index: trunk/src/VBox/Additions/x11/VBoxClient/draganddrop.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/draganddrop.cpp	(revision 80990)
+++ trunk/src/VBox/Additions/x11/VBoxClient/draganddrop.cpp	(revision 81028)
@@ -3044,12 +3044,4 @@
     LogFlowFuncEnter();
 
-    /* Initialise the guest library. */
-    int rc = VbglR3InitUser();
-    if (RT_FAILURE(rc))
-    {
-        VBClFatalError(("DnD: Failed to connect to the VirtualBox kernel service, rc=%Rrc\n", rc));
-        return rc;
-    }
-
     /* Connect to the x11 server. */
     m_pDisplay = XOpenDisplay(NULL);
@@ -3063,4 +3055,6 @@
     if (!pHelpers)
         return VERR_NO_MEMORY;
+
+    int rc;
 
     do
Index: trunk/src/VBox/Additions/x11/VBoxClient/hostversion.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/hostversion.cpp	(revision 80990)
+++ trunk/src/VBox/Additions/x11/VBoxClient/hostversion.cpp	(revision 81028)
@@ -130,8 +130,5 @@
 
     NOREF(ppInterface);
-    /* Initialise the guest library. */
-    rc = VbglR3InitUser();
-    if (RT_FAILURE(rc))
-        VBClFatalError(("Failed to connect to the VirtualBox kernel service, rc=%Rrc\n", rc));
+
     /* Because we need desktop notifications to be displayed, wait
      * some time to make the desktop environment load (as a work around). */
@@ -225,3 +222,2 @@
     return &pService->pInterface;
 }
-
Index: trunk/src/VBox/Additions/x11/VBoxClient/main.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/main.cpp	(revision 80990)
+++ trunk/src/VBox/Additions/x11/VBoxClient/main.cpp	(revision 81028)
@@ -250,4 +250,8 @@
         return RTMsgInitFailure(rc);
 
+    rc = VbglR3InitUser();
+    if (RT_FAILURE(rc))
+        return RTMsgErrorExitFailure("VbglR3InitUser failed: %Rrc", rc);
+
     /* This should never be called twice in one process - in fact one Display
      * object should probably never be used from multiple threads anyway. */
@@ -273,8 +277,4 @@
             /* If the user is running in "no daemon" mode anyway, send critical
              * logging to stdout as well. */
-            /** @todo r=bird: Since the release logger isn't created until the service
-             *        calls VbglR3InitUser or VbglR3Init or RTLogCreate, this whole
-             *        exercise is pointless.  Added --init-vbgl-user and --init-vbgl-full
-             *        for getting some work done. */
             PRTLOGGER pReleaseLog = RTLogRelGetDefaultInstance();
             if (pReleaseLog)
@@ -337,17 +337,4 @@
                 break;
             g_pService = VBClDisplaySVGAX11Service();
-        }
-        /* bird: this is just a quick hack to get something out of the LogRel statements in the code. */
-        else if (!strcmp(argv[i], "--init-vbgl-user"))
-        {
-            rc = VbglR3InitUser();
-            if (RT_FAILURE(rc))
-                return RTMsgErrorExitFailure("VbglR3InitUser failed: %Rrc", rc);
-        }
-        else if (!strcmp(argv[i], "--init-vbgl-full"))
-        {
-            rc = VbglR3Init();
-            if (RT_FAILURE(rc))
-                return RTMsgErrorExitFailure("VbglR3Init failed: %Rrc", rc);
         }
         else if (!strcmp(argv[i], "-h") || !strcmp(argv[i], "--help"))
Index: trunk/src/VBox/Additions/x11/VBoxClient/seamless.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/seamless.cpp	(revision 80990)
+++ trunk/src/VBox/Additions/x11/VBoxClient/seamless.cpp	(revision 81028)
@@ -286,13 +286,9 @@
 {
     struct SEAMLESSSERVICE *pSelf = getClassFromInterface(ppInterface);
-    int rc;
 
     if (pSelf->mIsInitialised)
         return VERR_INTERNAL_ERROR;
-    /* Initialise the guest library. */
-    rc = VbglR3InitUser();
-    if (RT_FAILURE(rc))
-        VBClFatalError(("Failed to connect to the VirtualBox kernel service, rc=%Rrc\n", rc));
-    rc = pSelf->mSeamless.init();
+
+    int rc = pSelf->mSeamless.init();
     if (RT_FAILURE(rc))
         return rc;